package com.rbg.ds18b20;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.rbg.ds18b20", "com.rbg.ds18b20.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.rbg.ds18b20", "com.rbg.ds18b20.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "com.rbg.ds18b20.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        Object[] o;
        if (permissions.length > 0)
            o = new Object[] {permissions[0], grantResults[0] == 0};
        else
            o = new Object[] {"", false};
        processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtip = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnconnect = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblstate = null;
public static double _temp1 = 0;
public static double _temp2 = 0;
public anywheresoftware.b4a.objects.LabelWrapper _lblreading1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblreading2 = null;
public static String[] _data = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnquit = null;
public speedometerviewwrapper.speedoMeterViewWrapper _sv1 = null;
public speedometerviewwrapper.speedoMeterViewWrapper _sv2 = null;
public com.rbg.ds18b20.starter _starter = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 42;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 43;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 77;BA.debugLine="sv1.MaxSpeed = 100";
mostCurrent._sv1.setMaxSpeed(100);
 //BA.debugLineNum = 78;BA.debugLine="sv1.addColoredRange(25.0, 50.0, Colors.Green)";
mostCurrent._sv1.addColoredRange(25.0,50.0,anywheresoftware.b4a.keywords.Common.Colors.Green);
 //BA.debugLineNum = 79;BA.debugLine="sv1.addColoredRange(50.0,75.0, Colors.Yellow)";
mostCurrent._sv1.addColoredRange(50.0,75.0,anywheresoftware.b4a.keywords.Common.Colors.Yellow);
 //BA.debugLineNum = 80;BA.debugLine="sv1.addColoredRange(75.0,100.0, Colors.Red)";
mostCurrent._sv1.addColoredRange(75.0,100.0,anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 81;BA.debugLine="sv1.Speed = 0.0";
mostCurrent._sv1.setSpeed(0.0);
 //BA.debugLineNum = 82;BA.debugLine="sv1.MajorTickStep = 10";
mostCurrent._sv1.setMajorTickStep(10);
 //BA.debugLineNum = 83;BA.debugLine="sv1.MinorTicks = 1";
mostCurrent._sv1.setMinorTicks((int) (1));
 //BA.debugLineNum = 84;BA.debugLine="sv1.LabelTextSize = 20";
mostCurrent._sv1.setLabelTextSize((int) (20));
 //BA.debugLineNum = 86;BA.debugLine="sv2.MaxSpeed = 100";
mostCurrent._sv2.setMaxSpeed(100);
 //BA.debugLineNum = 87;BA.debugLine="sv2.addColoredRange(20.0, 50.0, Colors.Green)";
mostCurrent._sv2.addColoredRange(20.0,50.0,anywheresoftware.b4a.keywords.Common.Colors.Green);
 //BA.debugLineNum = 88;BA.debugLine="sv2.addColoredRange(50.0,75.0, Colors.Yellow)";
mostCurrent._sv2.addColoredRange(50.0,75.0,anywheresoftware.b4a.keywords.Common.Colors.Yellow);
 //BA.debugLineNum = 89;BA.debugLine="sv2.addColoredRange(75.0,100.0, Colors.Red)";
mostCurrent._sv2.addColoredRange(75.0,100.0,anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 90;BA.debugLine="sv2.Speed =0.0";
mostCurrent._sv2.setSpeed(0.0);
 //BA.debugLineNum = 91;BA.debugLine="sv2.MajorTickStep = 10";
mostCurrent._sv2.setMajorTickStep(10);
 //BA.debugLineNum = 92;BA.debugLine="sv2.MinorTicks = 1";
mostCurrent._sv2.setMinorTicks((int) (1));
 //BA.debugLineNum = 93;BA.debugLine="sv2.LabelTextSize = 20";
mostCurrent._sv2.setLabelTextSize((int) (20));
 //BA.debugLineNum = 94;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 140;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 142;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 104;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 105;BA.debugLine="StateChanged";
_statechanged();
 //BA.debugLineNum = 106;BA.debugLine="End Sub";
return "";
}
public static String  _btnconnect_click() throws Exception{
 //BA.debugLineNum = 135;BA.debugLine="Sub btnConnect_Click";
 //BA.debugLineNum = 137;BA.debugLine="CallSub2(Starter, \"Connect\", edtIp.Text)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(mostCurrent.activityBA,(Object)(mostCurrent._starter.getObject()),"Connect",(Object)(mostCurrent._edtip.getText()));
 //BA.debugLineNum = 138;BA.debugLine="End Sub";
return "";
}
public static String  _btnquit_click() throws Exception{
 //BA.debugLineNum = 148;BA.debugLine="Sub btnQuit_Click";
 //BA.debugLineNum = 149;BA.debugLine="CallSub(Starter, \"disconnect\")";
anywheresoftware.b4a.keywords.Common.CallSubNew(mostCurrent.activityBA,(Object)(mostCurrent._starter.getObject()),"disconnect");
 //BA.debugLineNum = 150;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 //BA.debugLineNum = 151;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Private edtIp As EditText";
mostCurrent._edtip = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Private btnConnect As Button";
mostCurrent._btnconnect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Private lblState As Label";
mostCurrent._lblstate = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Private temp1,temp2 As Double";
_temp1 = 0;
_temp2 = 0;
 //BA.debugLineNum = 29;BA.debugLine="Private lblReading1 As Label";
mostCurrent._lblreading1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Private lblReading2 As Label";
mostCurrent._lblreading2 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Dim data() As String";
mostCurrent._data = new String[(int) (0)];
java.util.Arrays.fill(mostCurrent._data,"");
 //BA.debugLineNum = 36;BA.debugLine="Private btnQuit As Button";
mostCurrent._btnquit = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Private sv1 As SpeedometerView";
mostCurrent._sv1 = new speedometerviewwrapper.speedoMeterViewWrapper();
 //BA.debugLineNum = 39;BA.debugLine="Private sv2 As SpeedometerView";
mostCurrent._sv2 = new speedometerviewwrapper.speedoMeterViewWrapper();
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return "";
}
public static String  _newvalue(String _value) throws Exception{
 //BA.debugLineNum = 108;BA.debugLine="Public Sub NewValue(value As String)";
 //BA.debugLineNum = 109;BA.debugLine="data=Regex.Split(\":\",value)";
mostCurrent._data = anywheresoftware.b4a.keywords.Common.Regex.Split(":",_value);
 //BA.debugLineNum = 111;BA.debugLine="If data(0)=\"CH 1\" Then";
if ((mostCurrent._data[(int) (0)]).equals("CH 1")) { 
 //BA.debugLineNum = 112;BA.debugLine="temp1=data(1)";
_temp1 = (double)(Double.parseDouble(mostCurrent._data[(int) (1)]));
 //BA.debugLineNum = 113;BA.debugLine="lblReading1.Text = $\"Value = ${temp1}, Time = $T";
mostCurrent._lblreading1.setText((Object)(("Value = "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_temp1))+", Time = "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("time",(Object)(anywheresoftware.b4a.keywords.Common.DateTime.getNow()))+"")));
 };
 //BA.debugLineNum = 115;BA.debugLine="If data(0)=\"CH 2\" Then";
if ((mostCurrent._data[(int) (0)]).equals("CH 2")) { 
 //BA.debugLineNum = 116;BA.debugLine="temp2=data(1)";
_temp2 = (double)(Double.parseDouble(mostCurrent._data[(int) (1)]));
 //BA.debugLineNum = 117;BA.debugLine="lblReading2.Text = $\"Value = ${temp2}, Time = $T";
mostCurrent._lblreading2.setText((Object)(("Value = "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_temp2))+", Time = "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("time",(Object)(anywheresoftware.b4a.keywords.Common.DateTime.getNow()))+"")));
 };
 //BA.debugLineNum = 119;BA.debugLine="Try";
try { //BA.debugLineNum = 120;BA.debugLine="sv1.Speed =temp1";
mostCurrent._sv1.setSpeed(_temp1);
 //BA.debugLineNum = 121;BA.debugLine="sv2.Speed =temp2";
mostCurrent._sv2.setSpeed(_temp2);
 } 
       catch (Exception e14) {
			processBA.setLastException(e14); //BA.debugLineNum = 130;BA.debugLine="Log(\"Incorrect data format\")";
anywheresoftware.b4a.keywords.Common.Log("Incorrect data format");
 };
 //BA.debugLineNum = 132;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _statechanged() throws Exception{
 //BA.debugLineNum = 96;BA.debugLine="Public Sub StateChanged";
 //BA.debugLineNum = 97;BA.debugLine="If Starter.connected Then";
if (mostCurrent._starter._connected) { 
 //BA.debugLineNum = 98;BA.debugLine="lblState.Text = \"Connected\"";
mostCurrent._lblstate.setText((Object)("Connected"));
 }else {
 //BA.debugLineNum = 100;BA.debugLine="lblState.Text = \"Disconnected\"";
mostCurrent._lblstate.setText((Object)("Disconnected"));
 };
 //BA.debugLineNum = 102;BA.debugLine="End Sub";
return "";
}
}
